{*******************************************************}
{File:      NCOciLoginDlg.pas                           }
{Revision:  0.01.02 / 01.11.1999                        }
{Comment:   NC OCI8 VCL: Oracle8 login dialog           }
{Copyright: (c) 1999, Nica-Com Ltd.                     }
{Author:    Dmitry Arefiev, diman@ncom.ru               }
{*******************************************************}
{$I NCOciDef.inc}

unit NCOciLoginDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls, NCOci, NCOciWrapper, NCOciDB;

type
  TNCOciLoginFrm = class(TForm)
    PageControl1: TPageControl;
    tbshtLogin: TTabSheet;
    tbshtNewPassword: TTabSheet;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    pnlStd: TPanel;
    Label1: TLabel;
    edtUserName: TEdit;
    Label2: TLabel;
    edtPassword: TEdit;
    Label3: TLabel;
    cmbbxService: TComboBox;
    pnlAuthMode: TPanel;
    Label4: TLabel;
    cmbbxAuthMode: TComboBox;
    pnlProfile: TPanel;
    Label5: TLabel;
    cmbbxProfile: TComboBox;
    spdbttnDelProfile: TSpeedButton;
    Bevel1: TBevel;
    Label6: TLabel;
    edtNewPassword: TEdit;
    Memo1: TMemo;
    procedure cmbbxProfileClick(Sender: TObject);
    procedure spdbttnDelProfileClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    class function Execute(ADatabase: TOCIDatabase; AStdLogin: Boolean): Boolean;
  end;

var
  NCOciLoginFrm: TNCOciLoginFrm;

implementation

{$R *.DFM}

Uses Registry;

class function TNCOciLoginFrm.Execute(ADatabase: TOCIDatabase; AStdLogin: Boolean): Boolean;
begin
    if NCOciLoginFrm = nil then
{$IFDEF OCI_BCB}
        NCOciLoginFrm := TNCOciLoginFrm.Create(nil, 0);
{$ELSE}
        NCOciLoginFrm := TNCOciLoginFrm.Create(nil);
{$ENDIF}
    with NCOciLoginFrm do begin
        pnlAuthMode.Visible := lfMode in ADatabase.LoginFields;
        pnlProfile.Visible := lfProfile in ADatabase.LoginFields;
        edtUserName.Text := ADatabase.UserName;
        edtPassword.Text := ADatabase.Password;
        TOCIDatabase.GetObjectsList(ADatabase, cmbbxService.Items, '', okService, False);
        cmbbxService.Text := ADatabase.ServerName;
        if pnlAuthMode.Visible then
            cmbbxAuthMode.ItemIndex := Integer(ADatabase.AuthentMode);
        if pnlProfile.Visible then
            with TRegistry.Create do
            try
                RootKey := HKEY_CURRENT_USER;
                if OpenKeyReadOnly(SNCVCLRoot + SOCIProfiles) then
                    GetKeyNames(cmbbxProfile.Items)
                else
                    cmbbxProfile.Items.Clear;
            finally
                Free;
            end;
        Label1.Enabled := AStdLogin;
        Label2.Enabled := AStdLogin;
        Label3.Enabled := AStdLogin;
        if pnlAuthMode.Visible then
            Label4.Enabled := AStdLogin;
        if pnlProfile.Visible then
            Label5.Enabled := AStdLogin;
        edtUserName.Enabled := AStdLogin;
        edtPassword.Enabled := AStdLogin;
        cmbbxService.Enabled := AStdLogin;
        if pnlAuthMode.Visible then
            cmbbxAuthMode.Enabled := AStdLogin;
        if pnlProfile.Visible then begin
            cmbbxProfile.Enabled := AStdLogin;
            spdbttnDelProfile.Enabled := AStdLogin;
        end;
        Label6.Enabled := not AStdLogin;
        edtNewPassword.Enabled := not AStdLogin;
        tbshtNewPassword.TabVisible := not AStdLogin;
        tbshtLogin.TabVisible := not AStdLogin;
        if not AStdLogin then
            Height := 228
        else
            Height := 207;
        if AStdLogin then
            PageControl1.ActivePage := tbshtLogin
        else
            PageControl1.ActivePage := tbshtNewPassword;
        Result := ShowModal = mrOK;
        if Result then begin
            ADatabase.UserName := edtUserName.Text;
            ADatabase.Password := edtPassword.Text;
            ADatabase.ServerName := cmbbxService.Text;
            if pnlAuthMode.Visible then
                ADatabase.AuthentMode := TOCIAuthentMode(cmbbxAuthMode.ItemIndex);
            if pnlProfile.Visible then
                with TRegistry.Create do
                try
                    RootKey := HKEY_CURRENT_USER;
                    if OpenKey(SNCVCLRoot + SOCIProfiles + '\' +
                               UpperCase(cmbbxService.Text + ' - ' + edtUserName.Text), True) then begin
                        WriteString('UserName', edtUserName.Text);
                        WriteString('Password', edtPassword.Text);
                        WriteString('ServerName', cmbbxService.Text);
                        if pnlAuthMode.Visible then
                            WriteInteger('AuthentMode', cmbbxAuthMode.ItemIndex);
                    end;
                finally
                    Free;
                end;
        end;
    end;
    Application.ProcessMessages;
end;

procedure TNCOciLoginFrm.cmbbxProfileClick(Sender: TObject);
begin
    if pnlProfile.Visible then
        with TRegistry.Create do
        try
            RootKey := HKEY_CURRENT_USER;
            if OpenKeyReadOnly(SNCVCLRoot + SOCIProfiles + '\' + cmbbxProfile.Text) then begin
                edtUserName.Text := ReadString('UserName');
                edtPassword.Text := ReadString('Password');
                cmbbxService.Text := ReadString('ServerName');
                if pnlAuthMode.Visible then
                    cmbbxAuthMode.ItemIndex := ReadInteger('AuthentMode');
            end;
        finally
            Free;
        end;
end;

procedure TNCOciLoginFrm.spdbttnDelProfileClick(Sender: TObject);
begin
    if pnlProfile.Visible then
        with TRegistry.Create do
        try
            RootKey := HKEY_CURRENT_USER;
            DeleteKey(SNCVCLRoot + SOCIProfiles + '\' + cmbbxProfile.Text);
            cmbbxProfile.Items.Delete(cmbbxProfile.ItemIndex);
            cmbbxProfile.ItemIndex := -1;
            cmbbxProfile.Text := '';
        finally
            Free;
        end;
end;

initialization

    NCOciLoginFrm := nil;

finalization

    NCOciLoginFrm.Free;
    NCOciLoginFrm := nil;

end.
